distro specific fixes
[distro-setup] / ffs
1 #!/bin/bash
2 # I, Ian Kelling, follow the GNU license recommendations at
3 # https://www.gnu.org/licenses/license-recommendations.en.html. They
4 # recommend that small programs, < 300 lines, be licensed under the
5 # Apache License 2.0. This file contains or is part of one or more small
6 # programs. If a small program grows beyond 300 lines, I plan to change
7 # to a recommended GPL license.
8
9 # Copyright 2024 Ian Kelling
10
11 # Licensed under the Apache License, Version 2.0 (the "License");
12 # you may not use this file except in compliance with the License.
13 # You may obtain a copy of the License at
14
15 # http://www.apache.org/licenses/LICENSE-2.0
16
17 # Unless required by applicable law or agreed to in writing, software
18 # distributed under the License is distributed on an "AS IS" BASIS,
19 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
20 # See the License for the specific language governing permissions and
21 # limitations under the License.
22
23 # ffs = ffmpeg stream
24
25 # potential improvement: it might be nice that we could have a tall terminal but only use
26 # the top half for a 1080p stream, this is how:
27 # https://superuser.com/questions/1106674/how-to-add-blank-lines-above-the-bottom-in-terminal
28
29
30 if ! test "$BASH_VERSION"; then echo "error: shell is not bash" >&2; exit 1; fi
31 shopt -s inherit_errexit 2>/dev/null ||: # ignore fail in bash < 4.4
32 set -eE -o pipefail
33 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" exit status: $?, PIPESTATUS: ${PIPESTATUS[*]}" >&2' ERR
34
35 usage() {
36 cat <<EOF
37 Usage: ${0##*/} [OPTIONS] [sysops|tech|staff|test]
38
39 arg is icecast mountpoint suffix, except staff removes suffix.
40
41 -d debug.
42 -r RESOLUTION_TYPE
43 full: full screen even high resolution.
44 tall (default): half screen.
45 quarter: self evident
46 -l loud/listen. Start unmuted. Usually for testing.
47 -u Undelayed. Removes 5 second video delay, and about 4 second audio delay.
48 -w do not launch watch of stream
49
50 note: args duplicated in ffp
51
52
53 -h|--help Print help and exit.
54
55 Note: Uses util-linux getopt option parsing: spaces between args and
56 options, short options can be combined, options before args.
57 EOF
58 exit $1
59 }
60
61 ##### begin command line parsing ########
62
63 # ensure we can handle args with spaces or empty.
64 ret=0; getopt -T || ret=$?
65 [[ $ret == 4 ]] || { echo "Install util-linux for enhanced getopt" >&2; exit 1; }
66
67 ffp_args=()
68 debug=false
69 delay=true
70 loglevel=fatal
71 watch=true
72 volume=0
73 fullscreen=false
74 tall=true
75 temp=$(getopt -l help hdlr:uw "$@") || usage 1
76 eval set -- "$temp"
77 while true; do
78 case $1 in
79 -d)
80 debug=true
81 loglevel=debug
82 loglevel=info
83 ffp_args+=(-d)
84 ;;
85 -l)
86 volume=1
87 ;;
88 -r)
89 case $2 in
90 tall)
91 fullscreen=false
92 tall=true
93 ;;
94 quarter)
95 fullscreen=false
96 tall=false
97 ;;
98 full)
99 fullscreen=true
100 tall=false
101 ;;
102 esac
103 shift
104 ;;
105 -w)
106 watch=false
107 ;;
108 -u)
109 delay=false
110 ;;
111 -h|--help) usage ;;
112 --) shift; break ;;
113 *) echo "$0: unexpected args: $*" >&2 ; usage 1 ;;
114 esac
115 shift
116 done
117
118 mount_suffix=-sysops
119 if [[ $1 ]]; then
120 case $1 in
121 sysops|tech)
122 mount_suffix=-$1
123 ;;&
124 tech)
125 delay=false
126 ;;
127 staff)
128 mount_suffix=
129 ;;
130 *)
131 echo "error: unexpected \$1: $1" >&2
132 exit 1
133 ;;
134 esac
135 ffp_args+=($1)
136 fi
137
138 if $delay; then
139 # 2500 gets us around a 4 second delay, up from 1.5s.
140 delay_arg=,tpad=start_duration=2500ms
141 fi
142
143
144 ##### end command line parsing ########
145
146 host=live.iankelling.org:443
147 if ip n show 10.2.0.1 | grep . &>/dev/null && \
148 [[ $(dig +timeout=1 +short @10.2.0.1 -x 10.2.0.2 2>&1 ||:) == kd.b8.nz. ]]; then
149 host=127.0.0.1:8000
150 fi
151
152 pass=$(sed -n 's/ *<source-password>\([^<]*\).*/\1/p' /p/c/icecast.xml)
153
154
155 tmpf=$(mktemp)
156 xrandr >$tmpf
157
158 # example xrandr output: 1280x800+0+0
159 primary_res=$(awk '$2 == "connected" && $3 == "primary" { print $4 }' $tmpf | sed 's/+.*//')
160 tmp=$(awk '$2 == "connected" && $3 != "primary" { print $3 }' $tmpf | sed 's/+/ /g')
161 read -r secondary_res x_offset _ <<<"$tmp"
162
163
164 if [[ $secondary_res ]]; then
165 secondary_x=${secondary_res%%x*}
166 secondary_y=${secondary_res##*x}
167 if $fullscreen; then
168 stream_res=$secondary_res
169 elif $tall; then
170 stream_res=$(( secondary_x / 2 ))x$secondary_y
171 else
172 stream_res=$(( secondary_x / 2 ))x$(( secondary_y / 2))
173 fi
174 else
175 x_offset=0
176 stream_res=$primary_res
177 fi
178
179 # for 1080p, default 256k is poor quality. 500 is ok. 1500 is a bit
180 # better, so go with that. Also, that is about 2x what is recommended
181 # in https://livekit.io/webrtc/bitrate-guide (our framerate is lower).
182
183 bitrate=$(( ( ${stream_res/x/*} ) / 1380 ))
184
185 # 8 seems fine. be conservative by going a bit higher.
186 framerate=10
187 keyframe_interval=$((framerate * 2))
188
189 # Monitor of default sink.
190 # eg: alsa_output.usb-Audio-gd_Audio-gd-00.analog-stereo
191 pa_sink=$(pactl get-default-sink).monitor
192
193 # this is for ffmpeg warnings. doesnt seem to affect latency.
194 # 160 was too small. at 300, it occasionally complains,
195 # probably only when we are using delayed output
196 thread_queue_size_arg="-thread_queue_size 500"
197
198 opts=(
199 # global options
200 # be relatively quiet. switch to debug when testing.
201 -v $loglevel
202 -hide_banner
203 -nostats
204
205 # tested for decreasing latency: did not help.
206 # -probesize 32
207 # tested for warning "Queue input is backward in time". did not help.
208 #-rtbufsize 500M
209
210 # note: ordering of inputs also affects zmqsend commands.
211
212 ## audio input options
213
214 -f pulse
215 -name ffs
216 # note: duplicated
217 $thread_queue_size_arg
218 -fragment_size 512
219 -i default
220
221 -f pulse
222 $thread_queue_size_arg
223 # pulse knows this name somewhere
224 -name ffsdesktop
225 # This fixes latency. i haven't tried tuning it, but going too low creates
226 # choppy output.
227 -fragment_size 512
228 -i "$pa_sink"
229
230
231 ## video input options
232 -video_size $stream_res
233 $thread_queue_size_arg
234 -f x11grab
235 -framerate $framerate
236 -i :0.0+$x_offset.0
237
238 # Video + audio filter. Note: this has only the things we actually need in it.
239 #
240 # volume=precision=fixed fixes this error:
241 # The following filters could not choose their formats: Parsed_amerge_4.
242 #
243 # Default volume precision is float. Our input is fixed. maybe ffmpeg
244 # thinks the input could change and so can't commit to an output.
245 # The error suggests using aformat, which seems like it would probably
246 # also fix the error.
247 #
248 # man page say zmq url default includes "localhost", but specifying a
249 # localhost url caused an error for me.
250 -filter_complex "[0]azmq,volume=precision=fixed: volume=$volume [vol0];
251 [1]azmq='b=tcp\://127.0.0.1\:5556',volume=precision=fixed: volume=0 [vol1];
252 [vol0][vol1] amerge=inputs=2;
253 [2]zmq='b=tcp\://127.0.0.1\:5557',drawbox=color=0x262626,drawtext=fontsize=90: fontcolor=beige: x=40: y=40: text=''${delay_arg}[out]"
254
255 # An online source says to match a 5 second vid delay, we can do an
256 # audio delay filter: "adelay=5000|5000". However, we already get
257 # a stream delay of about 2 seconds, and having the audio be about
258 # 2 seconds ahead is fine, they do that intentionally in soccer
259 # matches.
260
261 # Based on error message and poking around, it seems ffmpeg is not
262 # smart enough to see that [vol0] and [vol1] are inputs to the amerge
263 # filter, and thus we would not want them as final outputs. So, we
264 # have to identify the amerge output and pass it to -out. This
265 # identifier is called an "output pad" in man ffmpeg-filters, and a
266 # "link label" in man ffmpeg.
267 -map '[out]'
268
269 # video output options
270 -vcodec libvpx
271 -g $keyframe_interval
272 -quality realtime
273 -b:v ${bitrate}k
274 -threads 2
275 -error-resilient 1
276
277 ## audio output options
278 -c:a libvorbis
279 -b:a 128k
280 # afaik, this ensures that the amerge doesn't make 4 channel output if
281 # our output format supported it.
282 -ac 2
283
284 -content_type video/webm
285 -f webm
286 icecast://source:$pass@$host/fsf$mount_suffix.webm
287 )
288
289 rm -f /tmp/iank-ffmpeg-interlude-toggle
290
291 # system mute. disabled, just using application level mute atm.
292 #
293 # pactl set-source-mute @DEFAULT_SOURCE@ true
294
295 if pkill -f ^ffmpeg.\*icecast://source.\*/fsf; then
296 sleep 1
297 fi
298
299 #echo executing: ffmpeg ${opts[@]}
300
301 #{ sleep 1; ffp &>/dev/null & }
302
303 if $debug; then
304 ffmpeg "${opts[@]}"
305 exit 0
306 fi
307
308 ##### begin clipboard history checkup ####
309
310 # Avoid streaming with secrets in our clipboard history. We could just
311 # clear the history, but here I truncate it to a max and then show it,
312 # and then I can press super+y if I want to clear it, or close the
313 # window if I want to keep it.
314 copyqcount=$(copyq count)
315 regex='^[1-9][0-9]*$'
316 if [[ $copyqcount =~ $regex ]]; then
317 # i dont want to think about more than this
318 max_rows=40
319 if (( copyqcount >= max_rows )); then
320 rows_arg=()
321 for ((i=max_rows; i<copyqcount; i++)); do
322 rows_arg+=($i)
323 done
324 copyq remove "${rows_arg[@]}"
325 fi
326 copyq show
327 gone=false
328 for (( i=0; i<40; i++ )); do
329 if i3-msg -t get_tree | jq -e '.. | select(.class? == "copyq" and .instance? == "copyq")' &>/dev/null; then
330 sleep .5
331 else
332 gone=true
333 break
334 fi
335 done
336 if ! $gone; then
337 msg="ffs: copyq not gone. aborting. super+y = copyq-restart / clear"
338 if [[ -t 0 ]]; then
339 echo $msg
340 else
341 dunstify -u critical -h string:x-dunst-stack-tag:alert "$msg"
342 fi
343 exit 1
344 fi
345 fi
346 ##### end clipboard history checkup ####
347
348 if [[ $mount_suffix == -sysops ]]; then
349 touch $HOME/.iank-stream-on
350 fi
351
352 echo $volume >$HOME/.iank-stream-muted
353
354 ffmpeg "${opts[@]}" &
355 if $watch; then
356 # watch the stream and end the stream when we stop watching.
357 sleep 2
358 ffp -d "${ffp_args[@]}" ||:
359 kill %%
360 rm -f $HOME/.iank-stream-on
361 fi
362
363
364
365 ### begin background/development docs ###
366
367 # zmq vs stdin commands:
368 #
369 # * zmq allows targeting a specific filter when there are duplicates.
370 #
371 # * if you type stdin command too slow, ffmpeg will die because it stops
372 # doing normal work while it is waiting.
373 #
374 # * zmq returns a result to the calling process, rather than printing to
375 # stdout.
376 #
377 # * the only simple zmq tool I found, zmqsend, requires compiling. I
378 # used the latest ffmpeg 7.0.1. Build like so:
379 #
380 # p build-dep ffmpeg/aramo
381 # ./configure --enable-libzmq # i already had libzmq3-dev installed
382 # make alltools
383 # cp tools/zmqsend /a/opt/bin
384 #
385 # * ffmpeg debug output was useful in testing zmq commands.
386 #
387 # * Important documentation for stdin commands is only found by typing
388 # "c" into the stdin of ffmpeg and reading the output.
389 #
390 #
391 #
392 # stdin command docs, before I abandoned it for zmq:
393 # mkfifo -m 0600 /tmp/iank-ffmpeg
394 # # ffmpeg sits and waits until we do this. dunno why.
395 # echo >/tmp/iank-ffmpeg &
396 # ffmpeg ... </tmp/iank-ffmpeg |& while read -r line; do : check results; done
397 # # example of working commands:
398 # echo "cdrawbox -1 t 0" >/tmp/iank-ffmpeg
399 # echo "cdrawbox -1 t fill" >/tmp/iank-ffmpeg
400 # echo "cdrawtext -1 reinit text=''" >/tmp/iank-ffmpeg
401 # echo "cvolume -1 volume=1" >/tmp/iank-ffmpeg
402
403
404 # For testing: to show the number of audio channels in a resulting file
405 # https://stackoverflow.com/questions/47905083/how-to-check-number-of-channels-in-my-audio-wav-file-using-ffmpeg-command
406 #
407 # ffprobe -i /tmp/out.wav -show_entries stream=channels -select_streams a:0 -of compact=p=0:nk=1 -v 0
408
409 # for a right/left speaker test:
410 # https://askubuntu.com/questions/148363/which-linux-command-can-i-use-to-test-my-speakers-for-current-talk-radio-output
411 # p install alsa-utils
412 # speaker-test -t wav -c 2 -l 1
413
414 # There are 2 other options for audio, so I wanted to do a little
415 # performance measurement of this method.
416 # 1 is to combine the 2 audio sources in pulse,
417 # https://unix.stackexchange.com/questions/351764/create-combined-source-in-pulseaudio .
418 # 1 is to record mumble and combine in post processing.
419
420 ### benchmark / perf tests: these are pretty inaccurate.
421 # 29 seconds cpu use. video bitrate 1500k, 8 fps, 2x keyframe interval.
422 # * 64k vorbis: 69.7%
423 # * 128k vorbis: 70.1% (used in subsequent tests)
424 # * 1 audio input: 64.3%
425 # * 0 audio inputs: 59.2%
426
427 # how I did perf testing: add -to 00:00:30 to ffmpeg opts to
428 # conveniently exit after measurement. Then run:
429 #
430 # ffmpeg "${opts[@]}" &
431 # pid=$!
432 # sleep 29
433 # ps -p $pid -o %cpu
434 # kill %%
435
436 # filter for only 1 audio input:
437 #-filter_complex "[0]azmq,volume=precision=fixed;[1]zmq='b=tcp\://127.0.0.1\:5557',drawbox=color=0x262626,drawtext=fontsize=90: fontcolor=beige: x=40: y=40: text=''"
438 # filter with 0 audio input:
439 # -filter_complex "[0]zmq='b=tcp\://127.0.0.1\:5557',drawbox=color=0x262626,drawtext=fontsize=90: fontcolor=beige: x=40: y=40: text=''"
440
441
442 # When things weren't working, I did some checking on newer ffmpeg to
443 # see if that helped. It never did. I compiled the latest ffmpeg release
444 # tarball, 7.0.1, and tried the version in debian bullseye by schrooting
445 # before running ffmpeg. Building was just configure; make, but then I
446 # found some flags that were needed. gpl flags r just because I noticed them.
447 # ./configure --enable-libzmq --enable-libpulse --enable-libvorbis --enable-gpl --enable-version3
448 #
449
450 ### end background/development docs ###